Option Strict Off
Option Explicit On
Module axedemo
	
	' Some API stuff
	' No need to understand - just copy and paste!
	
	Declare Function GetSystemDirectory Lib "kernel32"  Alias "GetSystemDirectoryA"(ByVal lpBuffer As String, ByVal nSize As Integer) As Integer
	Declare Function GetWindowsDirectory Lib "kernel32"  Alias "GetWindowsDirectoryA"(ByVal lpBuffer As String, ByVal nSize As Integer) As Integer
	Declare Function GetTempPath Lib "kernel32"  Alias "GetTempPathA"(ByVal nBufferLength As Integer, ByVal lpBuffer As String) As Integer
	
	Private Declare Function WaitForSingleObject Lib "kernel32" (ByVal hHandle As Integer, ByVal dwMilliseconds As Integer) As Integer
	
	Private Structure STARTUPINFO
		Dim cb As Integer
		Dim lpReserved As String
		Dim lpDesktop As String
		Dim lpTitle As String
		Dim dwX As Integer
		Dim dwY As Integer
		Dim dwXSize As Integer
		Dim dwYSize As Integer
		Dim dwXCountChars As Integer
		Dim dwYCountChars As Integer
		Dim dwFillAttribute As Integer
		Dim dwFlags As Integer
		Dim wShowWindow As Short
		Dim cbReserved2 As Short
		Dim lpReserved2 As Integer
		Dim hStdInput As Integer
		Dim hStdOutput As Integer
		Dim hStdError As Integer
	End Structure
	
	Private Structure PROCESS_INFORMATION
		Dim hProcess As Integer
		Dim hThread As Integer
		Dim dwProcessID As Integer
		Dim dwThreadID As Integer
	End Structure
	
	'UPGRADE_WARNING: Structure PROCESS_INFORMATION may require marshalling attributes to be passed as an argument in this Declare statement. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1050"'
	'UPGRADE_WARNING: Structure STARTUPINFO may require marshalling attributes to be passed as an argument in this Declare statement. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1050"'
	Private Declare Function CreateProcessA Lib "kernel32" (ByVal lpApplicationName As String, ByVal lpCommandLine As String, ByVal lpProcessAttributes As Integer, ByVal lpThreadAttributes As Integer, ByVal bInheritHandles As Integer, ByVal dwCreationFlags As Integer, ByVal lpEnvironment As Integer, ByVal lpCurrentDirectory As String, ByRef lpStartupInfo As STARTUPINFO, ByRef lpProcessInformation As PROCESS_INFORMATION) As Integer
	
	Private Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Integer) As Integer
	
	Private Declare Function GetExitCodeProcess Lib "kernel32" (ByVal hProcess As Integer, ByRef lpExitCode As Integer) As Integer
	
	Private Const NORMAL_PRIORITY_CLASS As Integer = &H20
	Private Const INFINITE As Short = -1
	
	Private Const STARTF_USESHOWWINDOW As Short = &H1s
	Private Const SW_HIDE As Short = 0
	Private Const SW_NORMAL As Short = 1
	
	
	Function GetTemp() As String
		'function to get windows temp path
		Dim retval As String
		Dim worked As Integer
		
		retval = New String(Chr(0), 255)
		worked = GetTempPath(Len(retval), retval)
		
		If worked = 0 Then
			GetTemp = VB6.GetPath & "\"
		Else
			GetTemp = Left(retval, worked)
		End If
		
	End Function
	
    Public Function ExecCmd(ByRef cmdline As String, ByRef show As Short) As Long
        'function to execute a command and wait for it to terminate
        ' if show = 0 then the console window is hidden
        ' if show = 1 then the console window is displayed

        Dim proc As PROCESS_INFORMATION
        Dim start As STARTUPINFO
        Dim Ret As Long

        ' Initialize the STARTUPINFO structure:
        start.cb = Len(start)
        start.dwFlags = STARTF_USESHOWWINDOW

        If show = 0 Then
            start.wShowWindow = SW_HIDE
        Else
            start.wShowWindow = SW_NORMAL
        End If

        ' Start the shelled application:
        Ret = CreateProcessA(vbNullString, cmdline, 0, 0, 1, NORMAL_PRIORITY_CLASS, 0, vbNullString, start, proc)

        ' Wait for the shelled application to finish:
        Ret = WaitForSingleObject(proc.hProcess, INFINITE)
        Call GetExitCodeProcess(proc.hProcess, Ret)
        Call CloseHandle(proc.hThread)
        Call CloseHandle(proc.hProcess)
        'UPGRADE_WARNING: Couldn't resolve default property of object ExecCmd. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1037"'
        ExecCmd = Ret
    End Function
End Module